#include <iostream>
#include <cstdio>

using namespace std;

int a[20005], n, m;

int main()
{
    freopen("asfalt.in", "r", stdin);
    freopen("asfalt.out", "w", stdout);
    int i, x, y, z, br=0, br1=0;
    scanf("%i %i", &n, &m);
    for(i=0; i<n; i++)
        a[i]=1;
    for(i=0; i<m; i++)
    {
        scanf("%i %i %i", &x, &y, &z);
        x--;
        y--;
        if(!z) a[x]=a[y]=0;
    }
    for(i=0; i<m; i++)
        if(a[i]) br++;
    printf("%i\n", br);
    for(i=0; i<m; i++)
        if(a[i])
        {
            printf("%i", i+1);
            br1++;
            if(br1!=br) printf(" ");
        }
    return 0;
}
